# Welcome to Solarus documentation

<div align="center" style="margin-bottom: 2em;">
  <img alt="Logo" src="assets/images/solarus_logo_framed.svg" width="300px"/>
</div>

Solarus is a **free and open-source game engine** for **2D games**, licensed under GPL v3. It is written from scratch in C++ and uses SDL2.

This website features these sections:

- [**Tutorial**](tutorials/introduction.md): A step-by-step guide to create a game with Solarus.
- [**Lua API Reference**](lua-api/introduction.md): A reference of everything that Solarus offers to make your game.
- [**Migration guide**](tutorials/migration/introduction.md): Instructions if you need to upgrade your game to the latest version of Solarus.
- [**Files Specifications**](files-specs/introduction.md): The specification of the format of every file of your game.
- [**Resources**](resources/introduction.md): Useful resources (scripts, graphics, music, etc.) for your game.

![Screenshot](assets/images/children-of-solarus-screenshot.webp)
