# Resource packs

Resources packs are collections of sprites, music, sounds, maps, etc. that you can use to create your own game.

## 100% Free

!!! success "What *Free* Means"

    The following resource packs are free and open-source. You can use them in a free or commercial project.

    - A **GPL/CC-BY-SA** license means that if you edit the resource, it must keep its original license, and you have to share your modifications with the community. Also, for GPL, the whole project must be GPL.
    - A **MIT/CC-BY** license means that you can use it more freely. Use it, edit it, keep it private if you want. It is more permissive. Just credit the original authors.
    - A **Public domain/CC-0** license means: do what you want.

    In every case, please **credit the authors**.

- [Solarus Free Resource Pack](https://gitlab.com/solarus-games/solarus-free-resource-pack)

    Contains only GPL and CC-BY-SA-licensed elements, scripts and resources in various styles, and my be used to bootstrap your first game.

    **License:** GPL, CC-BY-SA.

- [Solarus MIT Starter Quest](https://gitlab.com/Splyth/solarus-mit-starter-quest/-/tree/master/data)

    Contains only MIT-licensed scripts and Public Domain art assets, which means no GPL constraints. Useful for closed-source quests.

    **License:** MIT, CC-BY, CC-0.

- [Trilium](https://gitlab.com/maxmraz/trillium/)

    A very complete resource pack made by Max Mraz, the creator of Ocean's Heart. Licensed under MIT.

    **License:** MIT, CC-BY.

## The Legend of Zelda

!!! warning "About Copyright Infringement"

    The following resource packs contain sprites, tilesets, sounds, musics and other elements from *The Legend of Zelda*™ games that are copyrighted by Nintendo.

    - Using them to make a small game as a way to bootstrap your game dev learning process is fine, and will be considered **fair use**.
    - Using them to make a commercial game is plainly illegal.

- [A Link to the Past (SNES)](https://gitlab.com/solarus-games/solarus-alttp-pack)

    All you need to recreate a game in _ALTTP_ style. This resource pack is very full.

    **License:** Proprietary (Fair use), GPL.

- [Oracle of Ages/Oracle of Seasons (GBC)](https://github.com/Zunashy/GameboyRessourcePack/)

    In need of artists and developers to be completed.

- [The Legend of Zelda (NES)](http://forum.solarus-games.org/index.php/topic,1365.0.html)

    In need of artists and developers to be completed.

- [The Minish Cap (GBA)](http://forum.solarus-games.org/index.php/topic,1346.0.html)

    In need of artists and developers to be completed.
