# List of maps of the testing quest that are unit tests to be run
list(APPEND LUA_TEST_MAPS
  "all_entities"
  "basic_test"
  "dynamic_tile_tests"
  "jumper_tests"
  "lua_interface"
  "surface_tests"
  "oriented_collisions"
  "text_predict"
  "straight_movement"
  "custom_state/can_traverse"
  "custom_state/can_traverse_ground"
  "custom_state/carried_object"
  "custom_state/custom_state"
  "custom_state/draw_override"
  "custom_state/grabbing"
  "custom_state/jumper"
  "custom_state/pushing"
  "custom_state/reuse_state"
  "teletransportation_tests/main"
  "multiplayer/heroes"
  "multiplayer/cameras"
  "multiplayer/friendly_fire"
  "multiplayer/heroes_game_over"
  "multiplayer/controls"
  "event_order"
  "bugs/486_diagonal_dynamic_tiles"
  "bugs/496_stream_speed_0"
  "bugs/514_allow_x_y_parameters_to_entity_is_in_same_region"
  "bugs/526_get_entities_same_region"
  "bugs/630_change_resources"
  "bugs/633_straight_movement_speed_zero"
  "bugs/656_map_set_world"
  "bugs/664_chest_get_set_treasure"
  "bugs/667_hero_save_solid_ground_callback"
  "bugs/669_entity_get_sprite"
  "bugs/670_map_get_entities_no_hero"
  "bugs/671_collision_test_not_moving"
  "bugs/686_crash_door_item"
  "bugs/699_crash_exit_surface_moving"
  "bugs/712_npc_set_traversable"
  "bugs/716_custom_entity_set_can_traverse_door"
  "bugs/729_switch_is_walkable"
  "bugs/738_custom_entity_on_ground_below_changed"
  "bugs/748_entity_overlaps_collision_modes"
  "bugs/754_entity_get_max_bounding_box"
  "bugs/762_camera_entity"
  "bugs/769_stuck_dynamic_tile_covered"
  "bugs/771_spin_attack_ability"
  "bugs/779_get_entities_random_order"
  "bugs/781_assert_teletransporter_same_map"
  "bugs/794_custom_entity_set_can_traverse_ground"
  "bugs/795_recreate_entity_same_name"
  "bugs/796_map_get_entities_by_type"
  "bugs/805_hero_set_invincible"
  "bugs/807_cannot_traverse_own_ground"
  "bugs/808_get_entities_in_rectangle_duplicates"
  "bugs/809_entity_bring_sprite_to_front_back"
  "bugs/810_hero_disappears_after_scrolling/1"
  "bugs/817_entity_set_enabled_overlapping_hero"
  "bugs/818_sprite_get_num_frames"
  "bugs/819_destination_starting_location_mode/1"
  "bugs/821_hero_start_attack"
  "bugs/823_sprite_get_size_origin"
  "bugs/827_ground_detection_after_unfreeze"
  "bugs/830_entity_get_ground_position"
  "bugs/840_movement_get_type"
  "bugs/844_camera_on_state_changed"
  "bugs/845_game_set_suspended"
  "bugs/851_entity_get_sprites"
  "bugs/852_entity_create_sprite"
  "bugs/855_hero_get_sprite_wrong"
  "bugs/858_movement_get_set_ignore_suspend"
  "bugs/859_crash_game_start"
  "bugs/860_crash_remove_sprite"
  "bugs/861_sprite_set_animation_callback"
  "bugs/867_crash_crystal"
  "bugs/875_freeze_load_map_tiles_outside"
  "bugs/877_get_facing_entity"
  "bugs/880_custom_entity_set_origin"
  "bugs/883_collision_test_not_moving_sprite"
  "bugs/884_tileset_sprite_file_optional"
  "bugs/889_crash_use_non_saved_item"
  "bugs/898_entity_on_enabled"
  "bugs/920_game_on_world_changed/1"
  "bugs/937_custom_entity_missing_direction"
  "bugs/940_crash_bomb_on_stream"
  "bugs/945_flying_enemies_fall_in_hole"
  "bugs/946_reused_movement_callback"
  "bugs/954_entity_name_nil_after_removed"
  "bugs/955_enemy_get_set_dying_sprite_id"
  "bugs/967_blocks_max_moves"
  "bugs/971_sol_file_list"
  "bugs/983_timer_delay"
  "bugs/988_crash_treasure_dialog"
  "bugs/1007_door_open_close"
  "bugs/1024_custom_entity_set_origin"
  "bugs/1026_door_sprite_higher_than_16"
  "bugs/1036_falling_again_after_bad_ground"
  "bugs/1037_stairs_methods"
  "bugs/1038_hero_hurt_in_stairs"
  "bugs/1041_crash_entity_overlaps"
  "bugs/1042_multiple_facing_entities_random_picked"
  "bugs/1043_cannot_talk_to_npc_when_swimming"
  "bugs/1044_sol_menu_multiple_start"
  "bugs/1062_enemy_set_attack_consequence_callback"
  "bugs/1075_straight_movement_set_max_distance_tables"
  "bugs/1076_treasure_dialog_optional"
  "bugs/1091_circle_movement_get_center"
  "bugs/1092_enemy_is_immobilized"
  "bugs/1094_entity_properties"
  "bugs/1101_entity_enabled_at_start"
  "bugs/1105_custom_entity_repeat"
  "bugs/1107_menu_bring_to_front_back"
  "bugs/1116_angle_functions_radians"
  "bugs/1136_get_path_get_trajectory_missing_element"
  "bugs/1139_pickable_on_stream"
  "bugs/1158_entity_timer_suspended"
  "bugs/1159_entity_overlaps_sprites"
  "bugs/1162_custom_entity_collision_wrong_order"
  "bugs/1163_circular_movement_get_direction4"
  "bugs/1171_sword_knowledge_on_ability_used"
  "bugs/1175_dynamic_tile_set_get_tileset"
  "bugs/1179_enemy_on_restarted_called_twice"
  "bugs/1181_hurt_enemy_after_custom_attack"
  "bugs/1186_shallow_water_speed"
  "bugs/1193_entity_drawn_after_removed/map_1"
  "bugs/1195_enemy_dying_animation_never_finishes"
  "bugs/1214_blocks_in_water"
  "bugs/1221_custom_entity_follow_stream"
  "bugs/1228_crash_map_get_hero/1"
  "bugs/1230_entity_on_lifting"
  "bugs/1233_carried_object_events"
  "bugs/1236_entity_timer_not_suspended"
  "bugs/1247_hero_state_changing"
  "bugs/1260_entity_draw_override"
  "bugs/1261_entity_on_suspended"
  "bugs/1262_state_timers"
  "bugs/1264_sprite_is_animation_started"
  "bugs/1265_camera_get_surface"
  "bugs/1266_teletransporter_on_activated_disable"
  "bugs/1269_coroutines"
  "bugs/1268_movement_ignore_suspend_in_timer"
  "bugs/1275_map_set_tileset"
  "bugs/1286_crash_state_set_can_traverse"
  "bugs/1291_hero_start_attack_loading"
  "bugs/1297_target_movement_speed"
  "bugs/1301_state_set_can_be_hurt_function"
  "bugs/1319_disabled_entity_timer_unsuspended"
  "bugs/1348_hero_sprite_stuck"
  "bugs/1354_crash_start_movement"
  "bugs/1351_camera_stuck_on_separator"
  "bugs/1353_water_no_flippers"
  "bugs/1356_block_on_separator"
  "bugs/1361_crash_pickable_on_stream"
  "bugs/1364_state_set_can_use_stairs_not_working"
  "bugs/1366_crash_disabled_stairs_on_dynamic_tile"
  "bugs/1371_crash_pulling_block_on_switch"
  "bugs/1381_jumpers_hero_16_8"
  "bugs/1383_blocks_hero_16_8"
  "bugs/1392_carried_object_directions"
  "bugs/1395_large_map_memory_leak"
  "bugs/1407_facing_entity_not_updated"
  "bugs/1416_state_set_affected_by_ground_speed"
  "bugs/1418_state_set_can_be_hurt"
  "bugs/1419_crash_teletransporting_to_invalid_layer/map_1"
  "bugs/1423_crash_carried_without_shadow"
  "bugs/1424_rawget_rawset"
  "bugs/1425_is_in_same_region_4_way_separators"
  "bugs/1428_movement_blocking"
  "bugs/1436_thrown_object_shadow"
  "bugs/1439_ground_sprite_ladder"
  "bugs/1440_enemy_set_life_0_on_dying"
  "bugs/1448_custom_state_side_teletransporter"
  "bugs/1452_crash_carried_object"
  "bugs/1458_ground_sprite_when_jumping"
  "bugs/1461_tileset_sprite"
  "bugs/1471_pickable_wrong_layer"
  "bugs/1476_crash_command_binding"
  "bugs/1494_no_error_nonexistant_model"
  "bugs/1503_crash_invalid_save_file"
  "bugs/1508_carried_object_height"
  "bugs/1524_push_delay"
  "bugs/1526_destructible_cut_method"
  "bugs/1527_entity_set_name"
  "bugs/1533_savegame_write_escape"
  "bugs/1534_unicode_filenames"
  "bugs/1535_collision_moving_sprite"
  "bugs/1547_teletransporter_on_activated_twice/map_1"
  "bugs/1550_use_bow"
  "bugs/1551_error_teletransporter_set_destination_map"
  "bugs/1552_entire_savegame_access"
  "bugs/1556_boolean_parameters_treat_nil_as_true"
  "bugs/1562_crash_entity_on_stream"
  "bugs/1565_state_set_can_control_direction"
  "bugs/1583_crash_reset"
  "bugs/1585_get_entity_by_name"
  "bugs/1600_map_loading_single_cam/map1"
  "bugs/1609_crash_save_lua_keyword"
  "bugs/1611_entity_overlaps_when_removed"
  "bugs/1617_crash_disabled_chest"
  "bugs/1619_camera_obstacles"
  "bugs/1628_hero_set_direction_crash"
  "bugs/1635_timer_set_remaining_time"
  "bugs/1637_multi_items"
  "bugs/1639_destination_get_direction"
  "bugs/1641_crash_assign_item"
  "bugs/1644_random_movement_get_angle"
  "bugs/1648_custom_entities_collision_not_happening"
  "bugs/1652_npc_movement_stop_animation"
)

# Test that should succeed when there are non-fatal errors
list(APPEND LUA_TEST_MAPS_NON_FATAL
  "bugs/1015_crash_scrolling_to_invalid_layer/map_1"
  "bugs/1299_crash_invalid_tile_pattern"
  "bugs/1402_sol_sprite_create_invalid"
)

# Tests that require showing the window
list(APPEND LUA_TEST_MAPS_REQUIRE_WINDOW
  "bugs/1200_create_shader_from_source"
  "bugs/1210_shader_scaling_factor"
)
